from flask import Flask, render_template, request, redirect, url_for, flash
import random
import uuid
import os

app = Flask(__name__)
app.secret_key = str(uuid.uuid4())

# Simulated database
users = {}
reset_tokens = {}

# Function to generate 10000 random numbers and assign one to each user
def generate_random_numbers():
    random_numbers = [random.getrandbits(32) for _ in range(10000)]
    return random_numbers

random_numbers = generate_random_numbers()

def get_username_by_secret(users, secret):
    for username, info in users.items():
        if info.get('secret') == secret:
            return username
    return None

# Function to generate a random secret
def generate_secret(username):
    random_int = random_numbers.pop(0)
    return f"{username}-{random_int}"

@app.route('/')
def home():
    return render_template('login.html')

@app.route('/login', methods=['POST'])
def login():
    username = request.form['username']
    password = request.form['password']
    user = users.get(username)
    if user and user['password'] == password:
        if username == 'admin':
            flash(f"Welcome admin here is your flag {os.getenv('FLAG')}")
        flash(f"Welcome {username}! Your password reset token is {user['secret']}", 'success')
        return redirect(url_for('home'))
    else:
        flash('Invalid credentials', 'danger')
        return redirect(url_for('home'))

@app.route('/register', methods=['GET', 'POST'])
def register():
    if request.method == 'POST':
        username = request.form['username']
        password = request.form['password']
        if username in users:
            flash('User already exists', 'danger')
        else:
            if len(random_numbers) == 0:
                flash('No more random numbers available for registration', 'danger')
            else:
                secret = generate_secret(username)
                users[username] = {
                    'password': password,
                    'secret': secret
                }
                flash(f'Registration successful! Your password reset token is {secret}', 'success')
                return redirect(url_for('home'))
    return render_template('register.html')

@app.route('/reset_password', methods=['GET', 'POST'])
def reset_password():
    if request.method == 'POST':
        reset_token = request.form['reset_token']
        new_password = request.form['new_password']
        username = get_username_by_secret(users, reset_token)
        if username and username in users:
            users[username]['password'] = new_password
            flash('Password reset successful', 'success')
            return redirect(url_for('home'))
        else:
            flash('Invalid reset token', 'danger')
    return render_template('reset_password.html')

# Create an admin account 
if __name__ == '__main__':
    admin_secret = f"admin-{random_numbers[1499]}"
    users['admin'] = {
        'password': f'passdsipjfouyqevtwbnou074969546aYHGSHBKGH{str(uuid.uuid4())}',
        'secret': admin_secret
    }
    random_numbers.pop(1499)
    app.run(host='0.0.0.0')
